package de.drazil.homegear.controller;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import com.googlecode.jsonrpc4j.JsonRpcMethod;
import com.googlecode.jsonrpc4j.JsonRpcService;
import com.googlecode.jsonrpc4j.spring.AutoJsonRpcServiceImpl;

@JsonRpcService("/jsonrpc")
@AutoJsonRpcServiceImpl
public class HomegearJsonRpcEventControllerImpl { // implements
													// IHomegearJsonRpcEventController
													// {
	private static final Logger Log = Logger.getLogger("HomegearEventController");
	private static List<String> rpcMethodList = new ArrayList<String>();

	static {
		rpcMethodList.add("system.listMethods");
		rpcMethodList.add("event");
		rpcMethodList.add("error");
	}

	@JsonRpcMethod("system.listMethods")
	public List<String> listMethods() {
		return rpcMethodList;
	}

	@JsonRpcMethod("error")
	public void error(String interfaceId, Integer level, String message) {
		System.out.println("ERROR > interfaceId: " + interfaceId + " level: " + level + " message " + message);
	}

	@JsonRpcMethod("event")
	public void event(String interfaceId, Integer peerId, Integer channel, String parameterName, Object value) {
		System.out.println("EVENT > interfaceId: " + interfaceId + " peerId: " + peerId + " channel: " + channel
				+ " parameterName: " + parameterName + " value: " + value);
	}
}
